# https://qiita.com/karaage0703/items/f38d18afc1569fcc0418を参考にして情報Ⅱ用を作成した
# multiple_regression.py

# ライブラリーのインポート
# pandasで分析するcsvファイルを読み込みとファイルの冒頭部分の確認
import pandas as pd
from mpl_toolkits.mplot3d import Axes3D  #3Dplot
import matplotlib.pyplot as plt
%matplotlib inline
import seaborn as sns
from sklearn import preprocessing
from sklearn.linear_model import LinearRegression
import seaborn as sns
import numpy as np


# データをpandasで読み込む
df = pd.read_csv('male_high_school.csv', sep=',')
df.head()

# 入力データの5行分を出力
print(df.head())

# xに説明変数全体、x1に説明変数として立ち幅跳び、x2に説明変数としてハンドボール投げ、yに目的変数として50m走を入力
x = df[['立ち幅跳び', 'ハンドボール投げ']]
y = df[['50ｍ走']]
x1 = df[['立ち幅跳び']]
x2 = df[['ハンドボール投げ']]

print(x.shape)
print(y.shape)

# matplotlibで,x1, x2, yを3Dグラフで可視化

fig=plt.figure()
ax=Axes3D(fig)

ax.scatter3D(x1, x2, y)
ax.set_xlabel("x1")
ax.set_ylabel("x2")
ax.set_zlabel("y")

plt.show()

# scikit-learnのStandardScaleで正規化(分散を用いて標準化)

sscaler = preprocessing.StandardScaler()
sscaler.fit(x)
xss_sk = sscaler.transform(x) 
sscaler.fit(y)
yss_sk = sscaler.transform(y)

print(xss_sk)
print(yss_sk)

# scikit-learnを使った重回帰分析（正規化付き）

model_lr_std = LinearRegression()
model_lr_std.fit(xss_sk, yss_sk)

print("編回帰係数:",model_lr_std.coef_) 
print("切片:",model_lr_std.intercept_)  
print("決定係数R:",model_lr_std.score(xss_sk, yss_sk)) 

# 相関行列のseabornによる可視化

# 相関係数の計算
corr = np.corrcoef(xss_sk.T)

# 相関係数をヒートマップで可視化
sns.heatmap(corr, annot=True)
plt.show()

# 参考としてstatsmodelで一気に上記の統計量を計算する方法を以下に示します
# statsmodelを用いた統計量の計算
import statsmodels.api as sm

x_add_const = sm.add_constant(xss_sk)
model_sm = sm.OLS(yss_sk, x_add_const).fit()
print(model_sm.summary())
