# https://qiita.com/koshian2/items/71a28ad1e1c181153d05と
# https://qiita.com/renesisu727/items/e5191a97d3f16a14ebd0を基に作成
# 手書き数字をk-近傍法で判定、データはscikit-learnのデータセットを用いる
# kneighbor_mnist_like.py

# ライブラリーのインポート
import numpy as np
from sklearn.model_selection import train_test_split
from sklearn.neighbors import KNeighborsClassifier
from sklearn.datasets import load_digits
from sklearn import metrics

# 手書き数字データセットの取得
digits = load_digits()

# 特徴量Xとターゲットyに分離
X = digits.data
y = digits.target

# 学習データ8割、テストデータ2割で分割
train_X, test_X, train_y, test_y = train_test_split(X, y, test_size=0.2, random_state=114514)

# 学習データをノルムで標準化
norm = np.linalg.norm(train_X, ord=2, axis=1)
normalized_train_X = train_X / norm[:, np.newaxis]

# k-近傍法にょる予測（n_neighbors=6は最適化していません、変化させてみてください）
knn = KNeighborsClassifier(n_neighbors=6)
knn.fit(train_X, train_y)
pred_y = knn.predict(test_X)

# 予測値の精度を評価
print(metrics.accuracy_score(test_y, pred_y))

# 今回の出力結果(98%の正答率）
# 0.9833333333333333