##******************************************************************
#   糖尿病データの回帰分析 (dnn Keras+tensorflow)、BMI依存性の解析 *　　　　　　　　　　　　　　　　　　
#   参考　https://qiita.com/kotaroito/items/9e02e7378fc0053c01c0   *
#   data set from sklearn.datasets.load_diabetes                   *
#        copyright M. & S. Kogoshi, All right reserved             * 
##******************************************************************
# -*- coding: utf-8 -*-
import keras
from keras.models import Sequential
from keras.layers import Dense, Activation, Dropout
import numpy as np
import matplotlib.pyplot as plt
import sys
import pandas as pd
from sklearn.model_selection import train_test_split
from sklearn.preprocessing import StandardScaler
from sklearn.metrics import mean_squared_error
%matplotlib inline

# load of data
data_set = pd.read_csv("diabetes_train.csv",sep=",",header=0)

#separation of input(x) and target(y)
x = pd.DataFrame(data_set.drop("target",axis=1))
y = pd.DataFrame(data_set["target"])


#y_train creation for comparison
y1 = np.array(y.T)
y = y1[0]

# standardization of x
scaler = StandardScaler()
scaler.fit(x)
x_train = scaler.transform(x)


# input and output for keras
x_train = x_train.astype(np.float)

X = x_train
#y = y_train

# number,dimensio,class_number
(n_samples, n_features) = X.shape

# 4 layers
model = Sequential()
# input layer
model.add(Dense(units=8, activation='relu', input_shape=(n_features,)))
# Dropout
model.add(Dropout(0.1))
# second layer
model.add(Dense(units=8, activation='relu'))
# Dropout
model.add(Dropout(0.1))

#  層を増加する場合は以下の#を一個削除して下さい
## third layer
#model.add(Dense(units=64, activation='relu'))
## Dropout
#model.add(Dropout(0.1))
## fourth layer
#model.add(Dense(units=64, activation='relu'))
## Dropout
#model.add(Dropout(0.1))
## fifth layer
#model.add(Dense(units=64, activation='relu'))
## Dropout
#model.add(Dropout(0.1))
## 6th layer
#model.add(Dense(units=64, activation='relu'))
## Dropout
#model.add(Dropout(0.1))

# output layer
model.add(Dense(1))
model.summary

# compile
model.compile(loss='mean_squared_error', optimizer='adam', metrics=['mae'])

# learning
history = model.fit(X, y, epochs=300, validation_split=0.1, batch_size=16, verbose=2)

#loss_graph
plt.xlabel('time step')
plt.ylabel('loss val_loss')
plt.ylim(0,30000)
loss, = plt.plot(history.history['loss'], c='#E69F00')
val_loss, = plt.plot(history.history['val_loss'], c='#56B4E9')
plt.show()

# load of new_data
new_data = pd.read_csv("diabetes_test.csv",sep=",",header=0)

#change to form of DataFrame
x = pd.DataFrame(new_data.drop("target",axis=1))
y_test=pd.DataFrame(new_data["target"])

# standardization of x
x_test = scaler.transform(x)


# result
y_pred = model.predict(x_test, verbose=0)

mse = mean_squared_error(y_test,y_pred)

# csv output of test result
y_test = np.array(y_test)
data1 = np.c_[y_test, y_pred]
data1 = pd.DataFrame(data1)
np.savetxt('out.csv', data1, delimiter=',')


plt.xlabel('target_diabetes_risk_index')
plt.ylabel('predicted_diabetes_risk_index')
plt.xlim(0,300)
plt.ylim(0,300)

plt.scatter(y_test,y_pred,s=5)
plt.show()

print("KERAS RMSE: %.2f" %(mse**0.5))

# BMI dependenc of diabetes
# load of new_data
new_data = pd.read_csv("diabetes_test_bmi.csv",sep=",",header=0)

#change to form of DataFrame
x = pd.DataFrame(new_data.drop("target",axis=1))
bmi_test=pd.DataFrame(new_data["BMI"])

# standardization of x
x_test = scaler.transform(x)


# result
y_pred = model.predict(x_test, verbose=0)

#mse = mean_squared_error(y_test,y_pred)

# csv output of test result
bmi_test = np.array(bmi_test)
data1 = np.c_[bmi_test, y_pred]
data1 = pd.DataFrame(data1)
np.savetxt('out_bmi.csv', data1, delimiter=',')


plt.xlabel('BMI_test')
plt.ylabel('predicted_diabetes_risk_index')
plt.xlim(20,35)
plt.ylim(150,300)

plt.scatter(bmi_test,y_pred,s=5)
plt.show()

