# YOLOを使ってgoogle colabで画像検出を行う
# https://www.alpha.co.jp/blog/202108_02を参考にしています
# image_detection_yolo.py

!git clone https://github.com/ultralytics/yolov5
%cd /content/yolov5/
!pip install -qr requirements.txt
!python detect.py --source data/images/bus.jpg --conf 0.5 --weights yolov5s.pt

# 出力結果

#Cloning into 'yolov5'...
#remote: Enumerating objects: 14607, done.
#remote: Counting objects: 100% (161/161), done.
#remote: Compressing objects: 100% (65/65), done.
#remote: Total 14607 (delta 103), reused 148 (delta 96), pack-reused 14446
#Receiving objects: 100% (14607/14607), 13.50 MiB | 24.17 MiB/s, done.
#Resolving deltas: 100% (10076/10076), done.
#/content/yolov5
#     |████████████████████████████████| 1.6 MB 5.2 MB/s 
#detect: weights=['yolov5s.pt'], source=data/images/bus.jpg, data=data/coco128.yaml, imgsz=[640, 640], conf_thres=0.5, iou_thres=0.45, max_det=1000, device=, view_img=False, save_txt=False, save_conf=False, save_crop=False, nosave=False, classes=None, agnostic_nms=False, augment=False, visualize=False, update=False, project=runs/detect, name=exp, exist_ok=False, line_thickness=3, hide_labels=False, hide_conf=False, half=False, dnn=False, vid_stride=1
#YOLOv5 🚀 v6.2-228-g6ae3dff Python-3.7.15 torch-1.12.1+cu113 CPU

#Downloading https://github.com/ultralytics/yolov5/releases/download/v6.2/yolov5s.pt to yolov5s.pt...
#100% 14.1M/14.1M [00:00<00:00, 129MB/s]

#Fusing layers... 
#YOLOv5s summary: 213 layers, 7225885 parameters, 0 gradients
#image 1/1 /content/yolov5/data/images/bus.jpg: 640x480 4 persons, 1 bus, 418.0ms
#Speed: 5.3ms pre-process, 418.0ms inference, 23.0ms NMS per image at shape (1, 3, 640, 640)
#Results saved to runs/detect/exp

# runs/detect/expに計算結果の画像 bus.jpgが入っている
