# https://qiita.com/Ninagawa_Izumi/items/af7d704680fba63914e8と
# https://qiita.com/Ninagawa_Izumi/items/a49085e36e6de53b3ecaを参考に作成
# similarity_analysis.py
# 「走れメロス」太宰治を題材に単語の類似度を調べる

# リブラリーのインポート
from google.colab import files
import re

# 「走れメロス」のダウンロード
! wget https://www.aozora.gr.jp/cards/000035/files/1567_ruby_4948.zip
! unzip 1567_ruby_4948.zip
f = open('hashire_merosu.txt', 'r', encoding='SJIS')
data = f.read()
f.close()

# 不要部分の削除
data = re.sub("\u3000", "", data)
data = re.sub("\n", "", data)
data = re.sub("《[^》]+》", "", data)

data = re.sub("-------------------------------------------------------【テキスト中に現れる記号について】《》：ルビ（例）邪智暴虐｜：ルビの付く文字列の始まりを特定する記号（例）疲労｜困憊［＃］：入力者注主に外字の説明や、傍点の位置の指定（例）［＃地から１字上げ］-------------------------------------------------------", "", data)
data = re.sub("底本：「太宰治全集3」ちくま文庫、筑摩書房1988（昭和63）年10月25日初版発行1998（平成10）年6月15日第2刷底本の親本：「筑摩全集類聚版太宰治全集」筑摩書房1975（昭和50）年6月〜1976（昭和51）年6月入力：金川一之校正：高橋美奈子2000年12月4日公開2011年1月17日修正青空文庫作成ファイル：このファイルは、インターネットの図書館、青空文庫（http://www.aozora.gr.jp/）で作られました。入力、校正、制作にあたったのは、ボランティアの皆さんです。", "", data)

# 前処理した文章のダウンロード
f = open('data.txt', 'w')
f.write(data)
f.close()
files.download("data.txt")
data

# 残りの前処理
text = data.replace('、','')
text = text.replace('「','')
text = text.replace('」','')

text = text.split('。')

# python用mecabのインストール
! pip install mecab-python3 unidic-lite

import MeCab            #形態素解析ライブラリMeCabを導入する
tagger = MeCab.Tagger("-Owakati") #分かち書き用の関数を設定
j=0                     #リスト番号を数えるための変数
for i in text:          #textをリストの長さだけ処理していく
  i = tagger.parse(i)   #リストi番目のセンテンスを処理
  i2 = i.split(" ")     #i番目のセンテンスを処理してi2とする
  del i2[-1]            #単語リストの最後に改行が入るので削除しておく
  text[j]= i2           #リストj番目（=i番目)のデータを処理済みのものと差し替える
  j +=1                 #リスト番号を数えるための変数を更新

# gensismのインストール
! pip install gensim

import gensim
model = gensim.models.Word2Vec(text, size=100,min_count=1,window=5,iter=100)

model.wv.most_similar("濁流")

# 出力結果

#[('氾濫', 0.9943947196006775),
# ('滔々', 0.9941447377204895),
# ('あああ', 0.9938047528266907),
# ('下流', 0.9933035373687744),
# ('こめ', 0.992945671081543),
# ('外', 0.9928956627845764),
# ('激しく', 0.9928796291351318),
# ('せせら笑う', 0.9927712678909302),
# ('集り', 0.9927489757537842),
# ('ますます', 0.992516279220581)]

# 私の感想　類似度が高くないものも含まれている？